diff --git gcc/testsuite/gcc.target/aarch64/darwin/variadic-00.c gcc/testsuite/gcc.target/aarch64/darwin/variadic-00.c
new file mode 100644
index 000000000..6420fca11
--- /dev/null
+++ gcc/testsuite/gcc.target/aarch64/darwin/variadic-00.c
@@ -0,0 +1,91 @@
+/* { dg-do compile } */
+
+/* We use the sections anchors to make the code easier to match.  */
+/* { dg-additional-options " -O -fsection-anchors -fno-schedule-insns -fno-schedule-insns2 " } */
+/* { dg-final { check-function-bodies "**" "" "" { target *-*-darwin* } } } */
+
+#include <stdarg.h>
+
+/* What we care about here is that the load of w0 is from the incoming [SP]
+**fooi:
+**	sub	sp, sp, #16
+**	add	x[0-9]+, sp, 24
+**	str	x[0-9]+, \[sp, 8\]
+**	ldr	w0, \[sp, 16\]
+**	...
+*/
+
+__attribute__((__noinline__)) int
+fooi (int a, ...)
+{
+  int x;
+  va_list ap;
+  va_start(ap, a);
+  x = va_arg(ap, int);
+  va_end(ap);
+  return x;
+}
+
+__attribute__((__noinline__)) int
+fooo (char a, ...);
+
+/*
+**call_foo:
+**	...
+**	mov	w[0-9]+, 42
+**	str	w[0-9]+, \[sp\]
+**	mov	w0, 1
+**	bl	_fooo
+**	...
+*/
+
+__attribute__((__noinline__)) int
+call_foo (void)
+{
+  int y = fooo (1, 42);
+  return y;
+}
+
+/* What we care about here is that the load of w0 is from the incoming [SP+8]
+**bari:
+**	sub	sp, sp, #16
+**	add	x[0-9]+, sp, 32
+**	str	x[0-9]+, \[sp, 8\]
+**	ldr	w0, \[sp, 24\]
+**	...
+*/
+
+__attribute__((__noinline__)) int
+bari (int a, int b, int c, int d, int e, int f, int g, int h,
+      int i, ...)
+{
+  int x;
+  va_list ap;
+  va_start(ap, i);
+  x = va_arg(ap, int);
+  va_end(ap);
+  return x;
+}
+
+/*
+**call_bar:
+**	...
+**	mov	w[0-9]+, 42
+**	str	w[0-9]+, \[sp, 8\]
+**	mov	w[0-9]+, 9
+**	str	w[0-9]+, \[sp\]
+**	...
+	bl	_baro
+**	...
+*/
+
+__attribute__((__noinline__)) int
+baro (int a, int b, int c, int d, int e, int f, int g, int h,
+      int i, ...);
+
+__attribute__((__noinline__)) int
+call_bar (void)
+{
+  int y = baro (1, 2, 3, 4, 5, 6, 7, 8, 9, 42);
+  return y;
+}
diff --git gcc/testsuite/gcc.target/aarch64/darwin/variadic-01.c gcc/testsuite/gcc.target/aarch64/darwin/variadic-01.c
new file mode 100644
index 000000000..6134abdb7
--- /dev/null
+++ gcc/testsuite/gcc.target/aarch64/darwin/variadic-01.c
@@ -0,0 +1,104 @@
+/* { dg-do compile } */
+
+/* we need this for _Float128.  */
+/* { dg-options "-std=gnu99 " } */
+/* We use the sections anchors to make the code easier to match.  */
+/* { dg-additional-options " -O2 -fsection-anchors " } */
+/* { dg-final { check-function-bodies "**" "" "" { target *-*-darwin* } } } */
+
+#include <stdarg.h>
+
+/* What we care about here is that q0 and q1 are loaded from incoming sp and
+   sp+16.
+**foo:
+**	...
+**	mov	x29, sp
+**	add	(x[0-9]+), x29, 32
+**	...
+**	ldp	q1, q0, \[x29, 32\]
+**	...
+**	bl	___addtf3
+**	...
+*/
+
+__attribute__((__noinline__))
+_Float128
+foo (int n, ...)
+{
+  _Float128 a, b;
+  va_list ap;
+
+  va_start(ap, n);
+  a = va_arg(ap, _Float128);
+  b = va_arg(ap, _Float128);
+  va_end(ap); 
+  return a + b;
+}
+
+/*
+**call_foo:
+**	...
+**	mov	w0, 2
+**	stp	q[0-9]+, q[0-9]+, \[sp\]
+**	bl	_foo
+**	...
+*/
+
+__attribute__((__noinline__))
+_Float128
+call_foo (void)
+{
+  return foo (2, (_Float128)1.0, (_Float128)2.0);
+}
+
+/* What we care about here is that q0 and q1 are loaded from incoming sp and
+   sp+32 (with the int at sp+16).
+**bar:
+**	...
+**	ldr	w[0-9]+, \[x29, 48\]
+**	...
+**	ldr	q0, \[x29, 32\]
+**	...
+**	ldr	q1, \[x29, 64\]
+**	bl	___addtf3
+**	...
+*/
+
+__attribute__((__noinline__))
+_Float128
+bar (int n, ...)
+{
+  _Float128 a, b;
+  va_list ap;
+
+  va_start(ap, n);
+  a = va_arg(ap, _Float128);
+  n = va_arg(ap, int);
+  if (n != 42)
+    __builtin_abort ();
+  b = va_arg(ap, _Float128);
+  va_end(ap); 
+  return a + b;
+}
+
+/*
+**call_bar:
+**	...
+**	mov	(w[0-9]+), 42
+**	...
+**	str	\1, \[sp, 16\]
+**	...
+**	mov	w0, 2
+**	str	q[0-9]+, \[sp, 32\]
+**	str	q[0-9]+, \[sp\]
+**	bl	_bar
+**	...
+*/
+
+__attribute__((__noinline__))
+_Float128
+call_bar (void)
+{
+  return bar (2, (_Float128)1.0,
+	      42, (_Float128)2.0);
+}
diff --git gcc/testsuite/gcc.target/aarch64/darwin/variadic-02.c gcc/testsuite/gcc.target/aarch64/darwin/variadic-02.c
new file mode 100644
index 000000000..f85968510
--- /dev/null
+++ gcc/testsuite/gcc.target/aarch64/darwin/variadic-02.c
@@ -0,0 +1,102 @@
+/* { dg-do compile } */
+
+/* we need this for __int128.  */
+/* { dg-options "-std=gnu99 " } */
+/* We use the sections anchors to make the code easier to match.  */
+/* { dg-additional-options " -O2 -fsection-anchors " } */
+/* { dg-final { check-function-bodies "**" "" "" { target *-*-darwin* } } } */
+
+#include <stdarg.h>
+
+/* What we care about here is that we load the values from incoming sp and
+   sp + 16.
+**foo:
+**	sub	sp, sp, #16
+**	...
+**	ldp	x[0-9]+, x[0-9]+, \[sp, 16\]
+**	...
+**	ldp	x[0-9]+, x[0-9]+, \[sp, 32\]
+**	...
+*/
+
+__attribute__((__noinline__))
+__int128
+foo (int n, ...)
+{
+  __int128 a, b;
+  va_list ap;
+
+  va_start(ap, n);
+  a = va_arg(ap, __int128);
+  b = va_arg(ap, __int128);
+  va_end(ap); 
+  return a + b;
+}
+
+/*
+**call_foo:
+**	...
+**	mov	w0, 2
+**	stp	x[0-9]+, x[0-9]+, \[sp\]
+**	stp	x[0-9]+, x[0-9]+, \[sp, 16\]
+**	bl	_foo
+**	...
+*/
+
+__attribute__((__noinline__))
+__int128
+call_foo (void)
+{
+  return foo (2, (__int128)1, (__int128)2);
+}
+
+
+/* sp = one int128, sp+16 = int sp + 32 = other int128 
+**bar:
+**	...
+**	sub	sp, sp, #16
+**	...
+**	ldp	x[0-9]+, x[0-9]+, \[sp, 16\]
+**	...
+**	ldp	x[0-9]+, x[0-9]+, \[sp, 48\]
+**	...
+*/
+
+__attribute__((__noinline__))
+__int128
+bar (int n, ...)
+{
+  __int128 a, b;
+  va_list ap;
+
+  va_start(ap, n);
+  a = va_arg(ap, __int128);
+  n = va_arg(ap, int);
+  b = va_arg(ap, __int128);
+  va_end(ap); 
+  return a + b;
+}
+
+__attribute__((__noinline__))
+__int128
+baro (int n, ...);
+
+/*
+**call_bar:
+**	...
+**	mov	w[0-9]+, 42
+**	...
+**	mov	w0, 2
+**	stp	x[0-9]+, x[0-9]+, \[sp\]
+**	str	w[0-9]+, \[sp, 16\]
+**	stp	x[0-9]+, x[0-9]+, \[sp, 32\]
+**	bl	_baro
+**	...
+*/
+
+__attribute__((__noinline__))
+__int128
+call_bar (void)
+{
+  return baro (2, (__int128)1, 42, (__int128)2);
+}
diff --git gcc/testsuite/gcc.target/aarch64/dbl_mov_immediate_1.c gcc/testsuite/gcc.target/aarch64/dbl_mov_immediate_1.c
index fac32df8c..bc7106610 100644
--- gcc/testsuite/gcc.target/aarch64/dbl_mov_immediate_1.c
+++ gcc/testsuite/gcc.target/aarch64/dbl_mov_immediate_1.c
@@ -41,8 +41,10 @@ double d4(void)
 
 /* { dg-final { scan-assembler-times "movi\td\[0-9\]+, #?0"                 1 } } */
 
-/* { dg-final { scan-assembler-times "adrp\tx\[0-9\]+, "         2 } } */
-/* { dg-final { scan-assembler-times "ldr\td\[0-9\]+, \\\[x\[0-9\], #:lo12:" 2 } } */
+/* { dg-final { scan-assembler-times "adrp\tx\[0-9\]+, "         2 { target { ! *-*-darwin* } } } } */
+/* { dg-final { scan-assembler-times "ldr\td\[0-9\]+, \\\[x\[0-9\], #:lo12:" 2 { target { ! *-*-darwin* } } } } */
+/* { dg-final { scan-assembler-times "adrp\tx\[0-9\]+, lC\[0-9\]@PAGE" 2  { target *-*-darwin* } } } */
+/* { dg-final { scan-assembler-times "ldr\td\[0-9\]+, \\\[x\[0-9\], #lC\[0-9\]@PAGEOFF\\\]" 2  { target *-*-darwin* } } } */
 
 /* { dg-final { scan-assembler-times "fmov\td\[0-9\]+, 1\\\.5e\\\+0"        1 } } */
 
diff --git gcc/testsuite/gcc.target/aarch64/dwarf-cfa-reg.c gcc/testsuite/gcc.target/aarch64/dwarf-cfa-reg.c
index ae5b37970..8a691add2 100644
--- gcc/testsuite/gcc.target/aarch64/dwarf-cfa-reg.c
+++ gcc/testsuite/gcc.target/aarch64/dwarf-cfa-reg.c
@@ -1,5 +1,6 @@
 /* Verify that CFA register is restored to SP after FP is restored.  */
 /* { dg-do compile } */
+/* { dg-skip-if "no cfi insn support yet" *-*-darwin* } */
 /* { dg-options "-O0 -gdwarf-2" } */
 /* { dg-final { scan-assembler ".cfi_restore 30" } } */
 /* { dg-final { scan-assembler ".cfi_restore 29" } } */
diff --git gcc/testsuite/gcc.target/aarch64/extend.c gcc/testsuite/gcc.target/aarch64/extend.c
index f399e55ce..9556d4c2f 100644
--- gcc/testsuite/gcc.target/aarch64/extend.c
+++ gcc/testsuite/gcc.target/aarch64/extend.c
@@ -95,14 +95,16 @@ subdi_uxth (unsigned long long a, unsigned short i)
 unsigned long long
 subdi_uxth0 (unsigned long long a, unsigned short i)
 {
-  /* { dg-final { scan-assembler "sub\tx\[0-9\]+,.*uxth\n" } } */
+  /* { dg-final { scan-assembler "sub\tx\[0-9\]+,.*uxth\n" { target { ! *-*-darwin* } } } } */
+  /* { dg-final { scan-assembler "sub\tx\[0-9\]+,.*uxtw" { target *-*-darwin* } } } */
   return a - i;
 }
 
 long long
 subdi_sxth (long long a, short i)
 {
-  /* { dg-final { scan-assembler "sub\tx\[0-9\]+,.*sxth #?1" } } */
+  /* { dg-final { scan-assembler "sub\tx\[0-9\]+,.*sxth #?1" { target { ! *-*-darwin* } } } } */
+  /* { dg-final { scan-assembler "sub\tx\[0-9\]+,.*sxtw #?1" { target *-*-darwin* } } } */
   return a - ((long long)i << 1);
 }
 
@@ -116,55 +118,63 @@ subdi_sxth0 (long long a, short i)
 unsigned int
 subsi_uxth (unsigned int a, unsigned short i)
 {
-  /* { dg-final { scan-assembler "sub\tw\[0-9\]+,.*uxth #?1" } } */
+  /* { dg-final { scan-assembler "sub\tw\[0-9\]+,.*uxth #?1" { target { ! *-*-darwin* } } } } */
+  /* { dg-final { scan-assembler "sub\tw\[0-9\]+,.*lsl #?1" { target *-*-darwin* } } } */
   return a - ((unsigned int)i << 1);
 }
 
 unsigned int
 subsi_uxth0 (unsigned int a, unsigned short i)
 {
-  /* { dg-final { scan-assembler "sub\tw\[0-9\]+,.*uxth\n" } } */
+  /* { dg-final { scan-assembler "sub\tw\[0-9\]+,.*uxth\n" { target { ! *-*-darwin* } } } } */
+  /* { dg-final { scan-assembler "sub\tw\[0-9\]+, w\[0-9\]+, w\[0-9\]+" { target *-*-darwin* } } } */
   return a - i;
 }
 
 int
 subsi_sxth (int a, short i)
 {
-  /* { dg-final { scan-assembler "sub\tw\[0-9\]+,.*sxth #?1" } } */
+  /* { dg-final { scan-assembler "sub\tw\[0-9\]+,.*sxth #?1" { target { ! *-*-darwin* } } } } */
+  /* { dg-final { scan-assembler "sub\tw\[0-9\]+,.*lsl #?1" { target *-*-darwin* } } } */
   return a - ((int)i << 1);
 }
 
 int
 subsi_sxth0 (int a, short i)
 {
-  /* { dg-final { scan-assembler "sub\tw\[0-9\]+,.*sxth\n" } } */
+  /* { dg-final { scan-assembler "sub\tw\[0-9\]+,.*sxth\n" { target { ! *-*-darwin* } } } } */
+  /* { dg-final { scan-assembler "sub\tw\[0-9\]+, w\[0-9\]+, w\[0-9\]+" { target *-*-darwin* } } } */
   return a - (int)i;
 }
 
 unsigned int
 addsi_uxth (unsigned int a, unsigned short i)
 {
-  /* { dg-final { scan-assembler "add\tw\[0-9\]+,.*uxth #?1" } } */
+  /* { dg-final { scan-assembler "add\tw\[0-9\]+,.*uxth #?1" { target { ! *-*-darwin* } } } } */
+  /* { dg-final { scan-assembler "add\tw\[0-9\]+,.*lsl #?1" { target *-*-darwin* } } } */
   return a + ((unsigned int)i << 1);
 }
 
 unsigned int
 addsi_uxth0 (unsigned int a, unsigned short i)
 {
-  /* { dg-final { scan-assembler "add\tw\[0-9\]+,.*uxth\n" } } */
+  /* { dg-final { scan-assembler "add\tw\[0-9\]+,.*uxth\n" { target { ! *-*-darwin* } } } } */
+  /* { dg-final { scan-assembler "add\tw\[0-9\]+, w\[0-9\]+, w\[0-9\]+" { target *-*-darwin* } } } */
   return a + i;
 }
 
 int
 addsi_sxth (int a, short i)
 {
-  /* { dg-final { scan-assembler "add\tw\[0-9\]+,.*sxth #?1" } } */
+  /* { dg-final { scan-assembler "add\tw\[0-9\]+,.*sxth #?1" { target { ! *-*-darwin* } } } } */
+  /* { dg-final { scan-assembler "add\tw\[0-9\]+,.*lsl #?1" { target *-*-darwin* } } } */
   return a + ((int)i << 1);
 }
 
 int
 addsi_sxth0 (int a, short i)
 {
-  /* { dg-final { scan-assembler "add\tw\[0-9\]+,.*sxth\n" } } */
+  /* { dg-final { scan-assembler "add\tw\[0-9\]+,.*sxth\n" { target { ! *-*-darwin* } } } } */
+  /* { dg-final { scan-assembler "add\tw\[0-9\]+, w\[0-9\]+, w\[0-9\]+" { target *-*-darwin* } } } */
   return a + (int)i;
 }
diff --git gcc/testsuite/gcc.target/aarch64/fmov-1-be.c gcc/testsuite/gcc.target/aarch64/fmov-1-be.c
index 4227c6772..7e9431fbb 100644
--- gcc/testsuite/gcc.target/aarch64/fmov-1-be.c
+++ gcc/testsuite/gcc.target/aarch64/fmov-1-be.c
@@ -1,6 +1,7 @@
 /* { dg-do compile } */
 /* { dg-options "-O2 -mbig-endian" } */
 /* { dg-final { check-function-bodies "**" "" "" } } */
+/* { dg-skip-if "no big-endian support" *-*-darwin* } */
 
 #pragma GCC target ("arch=armv8-a")
 
diff --git gcc/testsuite/gcc.target/aarch64/fmov-2-be.c gcc/testsuite/gcc.target/aarch64/fmov-2-be.c
index 1e38066b4..16e0ed6d5 100644
--- gcc/testsuite/gcc.target/aarch64/fmov-2-be.c
+++ gcc/testsuite/gcc.target/aarch64/fmov-2-be.c
@@ -1,6 +1,7 @@
 /* { dg-do compile } */
 /* { dg-options "-O2 -mbig-endian" } */
 /* { dg-final { check-function-bodies "**" "" "" } } */
+/* { dg-skip-if "no big-endian support" *-*-darwin* } */
 
 #pragma GCC target ("arch=armv8.2-a+fp16")
 
diff --git gcc/testsuite/gcc.target/aarch64/fmov-3-be.c gcc/testsuite/gcc.target/aarch64/fmov-3-be.c
index 0bddd96ea..a718ec55f 100644
--- gcc/testsuite/gcc.target/aarch64/fmov-3-be.c
+++ gcc/testsuite/gcc.target/aarch64/fmov-3-be.c
@@ -1,6 +1,7 @@
 /* { dg-do compile } */
 /* { dg-options "-O2 -mbig-endian" } */
 /* { dg-final { check-function-bodies "**" "" "" } } */
+/* { dg-skip-if "no big-endian support" *-*-darwin* } */
 
 #pragma GCC target ("arch=armv8-a")
 
diff --git gcc/testsuite/gcc.target/aarch64/fmov-4-be.c gcc/testsuite/gcc.target/aarch64/fmov-4-be.c
index 58212ef43..d85b0f820 100644
--- gcc/testsuite/gcc.target/aarch64/fmov-4-be.c
+++ gcc/testsuite/gcc.target/aarch64/fmov-4-be.c
@@ -1,6 +1,7 @@
 /* { dg-do compile } */
 /* { dg-options "-O2 -mbig-endian" } */
 /* { dg-final { check-function-bodies "**" "" "" } } */
+/* { dg-skip-if "no big-endian support" *-*-darwin* } */
 
 #pragma GCC target ("arch=armv8.2-a+fp16")
 
diff --git gcc/testsuite/gcc.target/aarch64/fmov-5-be.c gcc/testsuite/gcc.target/aarch64/fmov-5-be.c
index 0fcefa7c9..84cae2790 100644
--- gcc/testsuite/gcc.target/aarch64/fmov-5-be.c
+++ gcc/testsuite/gcc.target/aarch64/fmov-5-be.c
@@ -1,6 +1,7 @@
 /* { dg-do compile } */
 /* { dg-options "-O2 -mbig-endian" } */
 /* { dg-final { check-function-bodies "**" "" "" } } */
+/* { dg-skip-if "no big-endian support" *-*-darwin* } */
 
 #pragma GCC target ("arch=armv8.2-a+fp16")
 
diff --git gcc/testsuite/gcc.target/aarch64/fmovld-zero-mem.c gcc/testsuite/gcc.target/aarch64/fmovld-zero-mem.c
index e649404ae..d17a889b3 100644
--- gcc/testsuite/gcc.target/aarch64/fmovld-zero-mem.c
+++ gcc/testsuite/gcc.target/aarch64/fmovld-zero-mem.c
@@ -1,8 +1,14 @@
 /* { dg-do compile } */
 /* { dg-options "-O2" } */
 
+#if __APPLE__
+#define F128TYPE __float128
+#else
+#define F128TYPE long double
+#endif
+
 void
-foo (long double *output)
+foo (F128TYPE *output)
 {
   *output = 0.0;
 }
diff --git gcc/testsuite/gcc.target/aarch64/fmovld-zero-reg.c gcc/testsuite/gcc.target/aarch64/fmovld-zero-reg.c
index ca602cb38..f9aa405a6 100644
--- gcc/testsuite/gcc.target/aarch64/fmovld-zero-reg.c
+++ gcc/testsuite/gcc.target/aarch64/fmovld-zero-reg.c
@@ -1,7 +1,13 @@
 /* { dg-do compile } */
 /* { dg-options "-O2" } */
 
-void bar (long double);
+#if __APPLE__
+#define F128TYPE __float128
+#else
+#define F128TYPE long double
+#endif
+
+void bar (F128TYPE);
 void
 foo (void)
 {
diff --git gcc/testsuite/gcc.target/aarch64/fuse_adrp_add_1.c gcc/testsuite/gcc.target/aarch64/fuse_adrp_add_1.c
index d66fe3a4b..1361452c6 100644
--- gcc/testsuite/gcc.target/aarch64/fuse_adrp_add_1.c
+++ gcc/testsuite/gcc.target/aarch64/fuse_adrp_add_1.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-require-effective-target aarch64_small } */
+/* { dg-skip-if "Darwin ABI indirects externs" { *-*-darwin* } } */
 /* { dg-options "-O3 -mcpu=cortex-a57 -fno-pie" } */
 
 enum reg_class { NO_REGS, AP_REG, XRF_REGS, GENERAL_REGS, AGRF_REGS,
diff --git gcc/testsuite/gcc.target/aarch64/indirect_return-1.c gcc/testsuite/gcc.target/aarch64/indirect_return-1.c
index 9ab133ffb..b177a6aaf 100644
--- gcc/testsuite/gcc.target/aarch64/indirect_return-1.c
+++ gcc/testsuite/gcc.target/aarch64/indirect_return-1.c
@@ -12,7 +12,7 @@ foo (int a)
 **func1:
 **	hint	34 // bti c
 **	...
-**	bl	foo
+**	bl	_?foo
 **	hint	36 // bti j
 **	...
 **	ret
@@ -27,7 +27,7 @@ func1 (int a, int b)
 **func2:
 **	hint	34 // bti c
 **	...
-**	b	foo
+**	b	_?foo
 */
 int __attribute((indirect_return,weak))
 func2 (int a, int b)
@@ -39,7 +39,7 @@ func2 (int a, int b)
 **func3:
 **	hint	34 // bti c
 **	...
-**	bl	func2
+**	bl	_?func2
 **	hint	36 // bti j
 **	...
 **	ret
diff --git gcc/testsuite/gcc.target/aarch64/indirect_return-2.c gcc/testsuite/gcc.target/aarch64/indirect_return-2.c
index 4759ed777..174789428 100644
--- gcc/testsuite/gcc.target/aarch64/indirect_return-2.c
+++ gcc/testsuite/gcc.target/aarch64/indirect_return-2.c
@@ -11,7 +11,7 @@ foo (int a)
 /*
 **func1:
 **	...
-**	bl	foo
+**	bl	_?foo
 **	...
 **	ret
 */
@@ -24,7 +24,7 @@ func1 (int a, int b)
 /*
 **func2:
 **	...
-**	b	foo
+**	b	_?foo
 */
 int __attribute((indirect_return,weak))
 func2 (int a, int b)
@@ -35,7 +35,7 @@ func2 (int a, int b)
 /*
 **func3:
 **	...
-**	bl	func2
+**	bl	_?func2
 **	...
 **	ret
 */
diff --git gcc/testsuite/gcc.target/aarch64/inline-lrint_1.c gcc/testsuite/gcc.target/aarch64/inline-lrint_1.c
index 478875ff8..9a2b2e448 100644
--- gcc/testsuite/gcc.target/aarch64/inline-lrint_1.c
+++ gcc/testsuite/gcc.target/aarch64/inline-lrint_1.c
@@ -15,4 +15,4 @@ TEST (fllf, float , long long, l)
 
 /* { dg-final { scan-assembler-times "frintx\t\[d,s\]\[0-9\]+, \[d,s\]\[0-9\]+" 6 } } */
 /* { dg-final { scan-assembler-times "fcvtzs\tx\[0-9\]+, \[d,s\]\[0-9\]+" 6 } } */
-/* { dg-final { scan-assembler-not "bl"    } } */
+/* { dg-final { scan-assembler-not "bl\t" } } */
diff --git gcc/testsuite/gcc.target/aarch64/inline-mem-set-pr112804.c gcc/testsuite/gcc.target/aarch64/inline-mem-set-pr112804.c
index 276c10cd0..7c3fa323e 100644
--- gcc/testsuite/gcc.target/aarch64/inline-mem-set-pr112804.c
+++ gcc/testsuite/gcc.target/aarch64/inline-mem-set-pr112804.c
@@ -1,4 +1,5 @@
 /* { dg-do compile } */
+/* { dg-skip-if "-mabi=ilp32 unsupported" { aarch64-*-darwin* } } */
 /* { dg-options "-finline-stringops -mabi=ilp32 -Wno-deprecated -ftrivial-auto-var-init=zero" } */
 
 short m(unsigned k) {
diff --git gcc/testsuite/gcc.target/aarch64/ins_bitfield_2.c gcc/testsuite/gcc.target/aarch64/ins_bitfield_2.c
index 152418889..cf37fb91c 100644
--- gcc/testsuite/gcc.target/aarch64/ins_bitfield_2.c
+++ gcc/testsuite/gcc.target/aarch64/ins_bitfield_2.c
@@ -1,5 +1,6 @@
 /* { dg-do assemble } */
 /* { dg-options "-O2 -mbig-endian --save-temps" } */
+/* { dg-skip-if "no BE" { *-*-darwin* } } */
 /* { dg-final { check-function-bodies "**" "" "" } } */
 
 typedef unsigned char v16qi __attribute__((vector_size(16)));
diff --git gcc/testsuite/gcc.target/aarch64/ins_bitfield_4.c gcc/testsuite/gcc.target/aarch64/ins_bitfield_4.c
index 98e25c869..ca428ea4e 100644
--- gcc/testsuite/gcc.target/aarch64/ins_bitfield_4.c
+++ gcc/testsuite/gcc.target/aarch64/ins_bitfield_4.c
@@ -1,5 +1,6 @@
 /* { dg-do assemble } */
 /* { dg-options "-O2 -mbig-endian --save-temps" } */
+/* { dg-skip-if "no BE" { *-*-darwin* } } */
 /* { dg-final { check-function-bodies "**" "" "" { target lp64 } } } */
 
 struct di_qi_1 { unsigned char c[4]; unsigned int x; };
diff --git gcc/testsuite/gcc.target/aarch64/ins_bitfield_6.c gcc/testsuite/gcc.target/aarch64/ins_bitfield_6.c
index cb8af6b06..21d56cba6 100644
--- gcc/testsuite/gcc.target/aarch64/ins_bitfield_6.c
+++ gcc/testsuite/gcc.target/aarch64/ins_bitfield_6.c
@@ -1,5 +1,6 @@
 /* { dg-do assemble } */
 /* { dg-options "-O2 -mbig-endian --save-temps" } */
+/* { dg-skip-if "no BE" { *-*-darwin* } } */
 /* { dg-final { check-function-bodies "**" "" "" } } */
 
 struct di_qi_1 { unsigned char c[4]; unsigned int x; };
diff --git gcc/testsuite/gcc.target/aarch64/ldar_1.c gcc/testsuite/gcc.target/aarch64/ldar_1.c
index d968a72b3..5fba03a18 100644
--- gcc/testsuite/gcc.target/aarch64/ldar_1.c
+++ gcc/testsuite/gcc.target/aarch64/ldar_1.c
@@ -1,6 +1,7 @@
 /* Test the LDAR instruction generation from atomic acquire loads.  */
 /* { dg-do assemble } */
 /* { dg-additional-options "--save-temps -O1" } */
+/* { dg-additional-options "--save-temps -O2" { target *-*-darwin* } } */
 /* { dg-final { check-function-bodies "**" "" "" } } */
 
 #include <stdint.h>
diff --git gcc/testsuite/gcc.target/aarch64/ldp_stp_14.c gcc/testsuite/gcc.target/aarch64/ldp_stp_14.c
index c7b5f7d6b..3cee5ba21 100644
--- gcc/testsuite/gcc.target/aarch64/ldp_stp_14.c
+++ gcc/testsuite/gcc.target/aarch64/ldp_stp_14.c
@@ -1,4 +1,5 @@
 /* { dg-options "-O2 -fno-tree-loop-distribute-patterns" } */
+/* { dg-additional-options "-mtune=generic -fomit-frame-pointer" { target *-*-darwin* } } */
 /* { dg-final { check-function-bodies "**" "" "" { target lp64 } } } */
 
 #include "ldp_stp_14.h"
diff --git gcc/testsuite/gcc.target/aarch64/ldp_stp_15.c gcc/testsuite/gcc.target/aarch64/ldp_stp_15.c
index 131cd0a63..f265b7a51 100644
--- gcc/testsuite/gcc.target/aarch64/ldp_stp_15.c
+++ gcc/testsuite/gcc.target/aarch64/ldp_stp_15.c
@@ -1,4 +1,5 @@
 /* { dg-options "-O2 -fno-tree-loop-distribute-patterns" } */
+/* { dg-additional-options "-mtune=generic -fomit-frame-pointer" { target *-*-darwin* } } */
 /* { dg-final { check-function-bodies "**" "" "" { target lp64 } } } */
 
 #include "ldp_stp_14.h"
diff --git gcc/testsuite/gcc.target/aarch64/ldp_stp_16.c gcc/testsuite/gcc.target/aarch64/ldp_stp_16.c
index 95835aa2e..252d756d5 100644
--- gcc/testsuite/gcc.target/aarch64/ldp_stp_16.c
+++ gcc/testsuite/gcc.target/aarch64/ldp_stp_16.c
@@ -1,4 +1,5 @@
 /* { dg-options "-O2 -fno-tree-loop-distribute-patterns" } */
+/* { dg-additional-options "-mtune=generic -fomit-frame-pointer" { target *-*-darwin* } } */
 /* { dg-final { check-function-bodies "**" "" "" { target lp64 } } } */
 
 #include "ldp_stp_14.h"
diff --git gcc/testsuite/gcc.target/aarch64/ldp_stp_18.c gcc/testsuite/gcc.target/aarch64/ldp_stp_18.c
index 49aa0b20a..84fcf63bd 100644
--- gcc/testsuite/gcc.target/aarch64/ldp_stp_18.c
+++ gcc/testsuite/gcc.target/aarch64/ldp_stp_18.c
@@ -1,4 +1,5 @@
 /* { dg-options "-O2 -fno-tree-loop-distribute-patterns" } */
+/* { dg-additional-options "-mtune=generic -fomit-frame-pointer" { target *-*-darwin* } } */
 /* { dg-final { check-function-bodies "**" "" "" { target lp64 } } } */
 
 #include "ldp_stp_14.h"
diff --git gcc/testsuite/gcc.target/aarch64/lse128-flag.c gcc/testsuite/gcc.target/aarch64/lse128-flag.c
index 71339c3af..2fbf3e84e 100644
--- gcc/testsuite/gcc.target/aarch64/lse128-flag.c
+++ gcc/testsuite/gcc.target/aarch64/lse128-flag.c
@@ -6,5 +6,6 @@ int main()
   return 0;
 }
 
-/* { dg-final { scan-assembler {\.arch armv9\.4-a\+crc\+lse128} } } */
+/* { dg-final { scan-assembler {\.arch armv9\.4-a\+crc\+lse128} { target { ! *-*-darwin* } } } } */
+/* { dg-final { scan-assembler {\.arch armv9\.4-a\+lse128} { target *-*-darwin* } } } */
 /* Test a normal looking procinfo.  */
diff --git gcc/testsuite/gcc.target/aarch64/memset-corner-cases-2.c gcc/testsuite/gcc.target/aarch64/memset-corner-cases-2.c
index 9ee96f332..dec73f985 100644
--- gcc/testsuite/gcc.target/aarch64/memset-corner-cases-2.c
+++ gcc/testsuite/gcc.target/aarch64/memset-corner-cases-2.c
@@ -7,7 +7,7 @@
 /* 127 bytes should use libcall for size.
 **set127byte:
 **	mov	x2, 127
-**	b	memset
+**	b	_?memset
 */
 void __attribute__((__noinline__))
 set127byte (int64_t *src, int c)
@@ -18,7 +18,7 @@ set127byte (int64_t *src, int c)
 /* 128 bytes should use libcall for size.
 **set128byte:
 **	mov	x2, 128
-**	b	memset
+**	b	_?memset
 */
 void __attribute__((__noinline__))
 set128byte (int64_t *src, int c)
diff --git gcc/testsuite/gcc.target/aarch64/memset-corner-cases.c gcc/testsuite/gcc.target/aarch64/memset-corner-cases.c
index 0b12c88c9..7f911a119 100644
--- gcc/testsuite/gcc.target/aarch64/memset-corner-cases.c
+++ gcc/testsuite/gcc.target/aarch64/memset-corner-cases.c
@@ -77,7 +77,7 @@ set256byte (int64_t *src, char c)
 **set257byte:
 **	mov	x2, 257
 **	mov	w1, 99
-**	b	memset
+**	b	_?memset
 */
 void __attribute__((__noinline__))
 set257byte (int64_t *src)
diff --git gcc/testsuite/gcc.target/aarch64/mops_4.c gcc/testsuite/gcc.target/aarch64/mops_4.c
index dd796115c..49b5c3966 100644
--- gcc/testsuite/gcc.target/aarch64/mops_4.c
+++ gcc/testsuite/gcc.target/aarch64/mops_4.c
@@ -124,9 +124,9 @@ set1 (char *x, char y, long z, char **res)
 **	ret
 */
 void
-set2 (char *x, char *yptr, long z, char *res)
+set2 (unsigned char *x, unsigned char *yptr, long z, unsigned char *res)
 {
-  char y = *yptr;
+  unsigned char y = *yptr;
   __builtin_memset (x, y, z);
   *res = y;
 }
diff --git gcc/testsuite/gcc.target/aarch64/movhi_1.c gcc/testsuite/gcc.target/aarch64/movhi_1.c
index 8017abc5f..145b9bae1 100644
--- gcc/testsuite/gcc.target/aarch64/movhi_1.c
+++ gcc/testsuite/gcc.target/aarch64/movhi_1.c
@@ -49,7 +49,7 @@ zero_to_fpr ()
 
 /*
 ** fpr_to_gpr:
-**	fmov	w0, s0
+**	(fmov	w0, s0|umov	w0, v0.h\[0\])
 **	ret
 */
 uint16_t
diff --git gcc/testsuite/gcc.target/aarch64/movqi_1.c gcc/testsuite/gcc.target/aarch64/movqi_1.c
index 401a79630..c1d93d55b 100644
--- gcc/testsuite/gcc.target/aarch64/movqi_1.c
+++ gcc/testsuite/gcc.target/aarch64/movqi_1.c
@@ -49,7 +49,7 @@ zero_to_fpr ()
 
 /*
 ** fpr_to_gpr:
-**	fmov	w0, s0
+**	(fmov	w0, s0|umov	w0, v0.b\[0\])
 **	ret
 */
 uint8_t
diff --git gcc/testsuite/gcc.target/aarch64/mv-1.c gcc/testsuite/gcc.target/aarch64/mv-1.c
index 6f095ecd7..eab320465 100644
--- gcc/testsuite/gcc.target/aarch64/mv-1.c
+++ gcc/testsuite/gcc.target/aarch64/mv-1.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 __attribute__ ((target_version ("default"))) int
 foo ()
diff --git gcc/testsuite/gcc.target/aarch64/mv-symbols1.c gcc/testsuite/gcc.target/aarch64/mv-symbols1.c
index 798227826..7549c58f3 100644
--- gcc/testsuite/gcc.target/aarch64/mv-symbols1.c
+++ gcc/testsuite/gcc.target/aarch64/mv-symbols1.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 // Basic case of fmv correctness with all functions and use in one TU.
 
diff --git gcc/testsuite/gcc.target/aarch64/mv-symbols10.c gcc/testsuite/gcc.target/aarch64/mv-symbols10.c
index d5256389d..0c41ccb33 100644
--- gcc/testsuite/gcc.target/aarch64/mv-symbols10.c
+++ gcc/testsuite/gcc.target/aarch64/mv-symbols10.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 int
 foo ();
diff --git gcc/testsuite/gcc.target/aarch64/mv-symbols11.c gcc/testsuite/gcc.target/aarch64/mv-symbols11.c
index fd3dc345a..70fd995fa 100644
--- gcc/testsuite/gcc.target/aarch64/mv-symbols11.c
+++ gcc/testsuite/gcc.target/aarch64/mv-symbols11.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 // Check that types can be combined
 
diff --git gcc/testsuite/gcc.target/aarch64/mv-symbols12.c gcc/testsuite/gcc.target/aarch64/mv-symbols12.c
index 1a0b667eb..1a9c6a706 100644
--- gcc/testsuite/gcc.target/aarch64/mv-symbols12.c
+++ gcc/testsuite/gcc.target/aarch64/mv-symbols12.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 __attribute__ ((target_version ("default"))) int
 foo () { return 1; }
diff --git gcc/testsuite/gcc.target/aarch64/mv-symbols13.c gcc/testsuite/gcc.target/aarch64/mv-symbols13.c
index 308dace64..7c520696c 100644
--- gcc/testsuite/gcc.target/aarch64/mv-symbols13.c
+++ gcc/testsuite/gcc.target/aarch64/mv-symbols13.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 __attribute__ ((target_version ("default"))) int
 foo ();
diff --git gcc/testsuite/gcc.target/aarch64/mv-symbols14.c gcc/testsuite/gcc.target/aarch64/mv-symbols14.c
index d1af69fe3..f7feaecbd 100644
--- gcc/testsuite/gcc.target/aarch64/mv-symbols14.c
+++ gcc/testsuite/gcc.target/aarch64/mv-symbols14.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 int foo ();
 
diff --git gcc/testsuite/gcc.target/aarch64/mv-symbols2.c gcc/testsuite/gcc.target/aarch64/mv-symbols2.c
index a8732caf2..14662dcfa 100644
--- gcc/testsuite/gcc.target/aarch64/mv-symbols2.c
+++ gcc/testsuite/gcc.target/aarch64/mv-symbols2.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 // FMV correctness with definitions but no call
 
diff --git gcc/testsuite/gcc.target/aarch64/mv-symbols3.c gcc/testsuite/gcc.target/aarch64/mv-symbols3.c
index 962bae935..21e75d6f3 100644
--- gcc/testsuite/gcc.target/aarch64/mv-symbols3.c
+++ gcc/testsuite/gcc.target/aarch64/mv-symbols3.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 // FMV correctness with declarations but no implementation
 
diff --git gcc/testsuite/gcc.target/aarch64/mv-symbols4.c gcc/testsuite/gcc.target/aarch64/mv-symbols4.c
index a476800b2..bddb0e7bf 100644
--- gcc/testsuite/gcc.target/aarch64/mv-symbols4.c
+++ gcc/testsuite/gcc.target/aarch64/mv-symbols4.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 // FMV correctness with a default implementation and declarations of other
 // versions
diff --git gcc/testsuite/gcc.target/aarch64/mv-symbols5.c gcc/testsuite/gcc.target/aarch64/mv-symbols5.c
index 4df20009f..d0b70bce7 100644
--- gcc/testsuite/gcc.target/aarch64/mv-symbols5.c
+++ gcc/testsuite/gcc.target/aarch64/mv-symbols5.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 // FMV correctness with default declaration, and implementations of other
 // versions.
diff --git gcc/testsuite/gcc.target/aarch64/mv-symbols6.c gcc/testsuite/gcc.target/aarch64/mv-symbols6.c
index cbf8bcaf8..128d479e7 100644
--- gcc/testsuite/gcc.target/aarch64/mv-symbols6.c
+++ gcc/testsuite/gcc.target/aarch64/mv-symbols6.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 __attribute__ ((target_version ("default"))) int
 foo ()
diff --git gcc/testsuite/gcc.target/aarch64/mv-symbols7.c gcc/testsuite/gcc.target/aarch64/mv-symbols7.c
index 2ea4d2ebf..d2b3c257e 100644
--- gcc/testsuite/gcc.target/aarch64/mv-symbols7.c
+++ gcc/testsuite/gcc.target/aarch64/mv-symbols7.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 __attribute__ ((target_version ("dotprod"))) int
 foo ();
diff --git gcc/testsuite/gcc.target/aarch64/mv-symbols8.c gcc/testsuite/gcc.target/aarch64/mv-symbols8.c
index 3e3eaf21a..32229749e 100644
--- gcc/testsuite/gcc.target/aarch64/mv-symbols8.c
+++ gcc/testsuite/gcc.target/aarch64/mv-symbols8.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 __attribute__ ((target_version ("dotprod"))) int
 foo ();
diff --git gcc/testsuite/gcc.target/aarch64/mv-symbols9.c gcc/testsuite/gcc.target/aarch64/mv-symbols9.c
index 8e0864f16..ac5dc5c33 100644
--- gcc/testsuite/gcc.target/aarch64/mv-symbols9.c
+++ gcc/testsuite/gcc.target/aarch64/mv-symbols9.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 __attribute__ ((target_version ("dotprod"))) int
 foo ();
diff --git gcc/testsuite/gcc.target/aarch64/mvc-symbols1.c gcc/testsuite/gcc.target/aarch64/mvc-symbols1.c
index 3ad15e5bb..cd3150b70 100644
--- gcc/testsuite/gcc.target/aarch64/mvc-symbols1.c
+++ gcc/testsuite/gcc.target/aarch64/mvc-symbols1.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 __attribute__ ((target_clones ("default", "dotprod", "sve+sve2"))) int
 foo ()
diff --git gcc/testsuite/gcc.target/aarch64/mvc-symbols2.c gcc/testsuite/gcc.target/aarch64/mvc-symbols2.c
index 78385ed90..b7b7a42f9 100644
--- gcc/testsuite/gcc.target/aarch64/mvc-symbols2.c
+++ gcc/testsuite/gcc.target/aarch64/mvc-symbols2.c
@@ -1,5 +1,6 @@
 /* { dg-do compile } */
 /* { dg-options "-O0" } */
+/* { dg-require-ifunc "" } */
 
 __attribute__ ((target_clones ("default", "dotprod", "sve+sve2"))) int
 foo ()
